Index: trunk/source/persistency/gdml/src/G4GDMLWriteStructure.cc
===================================================================
--- trunk/source/persistency/gdml/src/G4GDMLWriteStructure.cc	(revision 1227)
+++ trunk/source/persistency/gdml/src/G4GDMLWriteStructure.cc	(revision 1228)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4GDMLWriteStructure.cc,v 1.74 2008/11/13 16:48:19 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// $Id: G4GDMLWriteStructure.cc,v 1.80 2009/04/24 15:34:20 gcosmo Exp $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // class G4GDMLWriteStructure Implementation
@@ -35,4 +35,24 @@
 
 #include "G4GDMLWriteStructure.hh"
+
+#include "G4Material.hh"
+#include "G4ReflectedSolid.hh"
+#include "G4DisplacedSolid.hh"
+#include "G4LogicalVolumeStore.hh"
+#include "G4PhysicalVolumeStore.hh"
+#include "G4PVDivision.hh"
+#include "G4PVReplica.hh"
+#include "G4OpticalSurface.hh"
+#include "G4LogicalSkinSurface.hh"
+#include "G4LogicalBorderSurface.hh"
+
+G4GDMLWriteStructure::G4GDMLWriteStructure()
+  : G4GDMLWriteParamvol()
+{
+}
+
+G4GDMLWriteStructure::~G4GDMLWriteStructure()
+{
+}
 
 void
@@ -50,9 +70,9 @@
    G4String unitString("mm");
    G4String axisString("kUndefined");
-   if (axis==kXAxis) { axisString = "kXAxis"; } else
-   if (axis==kYAxis) { axisString = "kYAxis"; } else
-   if (axis==kZAxis) { axisString = "kZAxis"; } else
-   if (axis==kRho) { axisString = "kRho";     } else
-   if (axis==kPhi) { axisString = "kPhi"; unitString = "degree"; }
+   if (axis==kXAxis) { axisString = "kXAxis"; }
+   else if (axis==kYAxis) { axisString = "kYAxis"; }
+   else if (axis==kZAxis) { axisString = "kZAxis"; }
+   else if (axis==kRho)   { axisString = "kRho";     }
+   else if (axis==kPhi)   { axisString = "kPhi"; unitString = "degree"; }
 
    const G4String name
@@ -154,14 +174,18 @@
    volumerefElement->setAttributeNode(NewAttribute("ref",volumeref));
    replicavolElement->appendChild(volumerefElement);
-
    xercesc::DOMElement* replicateElement = NewElement("replicate_along_axis");
    replicavolElement->appendChild(replicateElement);
 
    xercesc::DOMElement* dirElement = NewElement("direction");
-   if(axis==kXAxis)dirElement->setAttributeNode(NewAttribute("x","1"));
-   if(axis==kYAxis)dirElement->setAttributeNode(NewAttribute("y","1"));
-   if(axis==kZAxis)dirElement->setAttributeNode(NewAttribute("z","1"));
-   if(axis==kRho)dirElement->setAttributeNode(NewAttribute("rho","1"));
-   if(axis==kPhi)dirElement->setAttributeNode(NewAttribute("phi","1"));
+   if(axis==kXAxis)
+     { dirElement->setAttributeNode(NewAttribute("x","1")); }
+   else if(axis==kYAxis)
+     { dirElement->setAttributeNode(NewAttribute("y","1")); }
+   else if(axis==kZAxis)
+     { dirElement->setAttributeNode(NewAttribute("z","1")); }
+   else if(axis==kRho)
+     { dirElement->setAttributeNode(NewAttribute("rho","1")); }
+   else if(axis==kPhi)
+     { dirElement->setAttributeNode(NewAttribute("phi","1")); }
    replicateElement->appendChild(dirElement);
 
@@ -179,4 +203,135 @@
 }
 
+void G4GDMLWriteStructure::
+BorderSurfaceCache(const G4LogicalBorderSurface* const bsurf)
+{
+   if (!bsurf)  { return; }
+
+   const G4SurfaceProperty* psurf = bsurf->GetSurfaceProperty();
+
+   // Generate the new element for border-surface
+   //
+   xercesc::DOMElement* borderElement = NewElement("bordersurface");
+   borderElement->setAttributeNode(NewAttribute("name", bsurf->GetName()));
+   borderElement->setAttributeNode(NewAttribute("surfaceproperty",
+                                                psurf->GetName()));
+
+   const G4String volumeref1 = GenerateName(bsurf->GetVolume1()->GetName(),
+                                            bsurf->GetVolume1());
+   const G4String volumeref2 = GenerateName(bsurf->GetVolume2()->GetName(),
+                                            bsurf->GetVolume2());
+   xercesc::DOMElement* volumerefElement1 = NewElement("physvolref");
+   xercesc::DOMElement* volumerefElement2 = NewElement("physvolref");
+   volumerefElement1->setAttributeNode(NewAttribute("ref",volumeref1));
+   volumerefElement2->setAttributeNode(NewAttribute("ref",volumeref2));
+   borderElement->appendChild(volumerefElement1);
+   borderElement->appendChild(volumerefElement2);
+
+   if (FindOpticalSurface(psurf))
+   {
+     OpticalSurfaceWrite(solidsElement,
+                         dynamic_cast<const G4OpticalSurface*>(psurf));
+   }
+
+   borderElementVec.push_back(borderElement);
+}
+
+void G4GDMLWriteStructure::
+SkinSurfaceCache(const G4LogicalSkinSurface* const ssurf)
+{
+   if (!ssurf)  { return; }
+
+   const G4SurfaceProperty* psurf = ssurf->GetSurfaceProperty();
+
+   // Generate the new element for border-surface
+   //
+   xercesc::DOMElement* skinElement = NewElement("skinsurface");
+   skinElement->setAttributeNode(NewAttribute("name", ssurf->GetName()));
+   skinElement->setAttributeNode(NewAttribute("surfaceproperty",
+                                              psurf->GetName()));
+
+   const G4String volumeref = GenerateName(ssurf->GetLogicalVolume()->GetName(),
+                                           ssurf->GetLogicalVolume());
+   xercesc::DOMElement* volumerefElement = NewElement("volumeref");
+   volumerefElement->setAttributeNode(NewAttribute("ref",volumeref));
+   skinElement->appendChild(volumerefElement);
+
+   if (FindOpticalSurface(psurf))
+   {
+     OpticalSurfaceWrite(solidsElement,
+                         dynamic_cast<const G4OpticalSurface*>(psurf));
+   }
+
+   skinElementVec.push_back(skinElement);
+}
+
+G4bool G4GDMLWriteStructure::FindOpticalSurface(const G4SurfaceProperty* psurf)
+{
+   const G4OpticalSurface* osurf = dynamic_cast<const G4OpticalSurface*>(psurf);
+   std::vector<const G4OpticalSurface*>::const_iterator pos;
+   pos = std::find(opt_vec.begin(), opt_vec.end(), osurf);
+   if (pos != opt_vec.end()) { return false; }  // item already created!
+
+   opt_vec.push_back(osurf);              // cache it for future reference
+   return true;
+}
+
+const G4LogicalSkinSurface*
+G4GDMLWriteStructure::GetSkinSurface(const G4LogicalVolume* const lvol)
+{
+  G4LogicalSkinSurface* surf = 0;
+  G4int nsurf = G4LogicalSkinSurface::GetNumberOfSkinSurfaces();
+  if (nsurf)
+  {
+    const G4LogicalSkinSurfaceTable* stable =
+          G4LogicalSkinSurface::GetSurfaceTable();
+    std::vector<G4LogicalSkinSurface*>::const_iterator pos;
+    for (pos = stable->begin(); pos != stable->end(); pos++)
+    {
+      if (lvol == (*pos)->GetLogicalVolume())
+      {
+        surf = *pos; break;
+      }
+    }
+  }
+  return surf;
+}
+
+const G4LogicalBorderSurface*
+G4GDMLWriteStructure::GetBorderSurface(const G4VPhysicalVolume* const pvol)
+{
+  G4LogicalBorderSurface* surf = 0;
+  G4int nsurf = G4LogicalBorderSurface::GetNumberOfBorderSurfaces();
+  if (nsurf)
+  {
+    const G4LogicalBorderSurfaceTable* btable =
+          G4LogicalBorderSurface::GetSurfaceTable();
+    std::vector<G4LogicalBorderSurface*>::const_iterator pos;
+    for (pos = btable->begin(); pos != btable->end(); pos++)
+    {
+      if (pvol == (*pos)->GetVolume1())  // just the first in the couple 
+      {                                  // is enough
+        surf = *pos; break;
+      }
+    }
+  }
+  return surf;
+}
+
+void G4GDMLWriteStructure::SurfacesWrite()
+{
+   G4cout << "G4GDML: Writing surfaces..." << G4endl;
+
+   std::vector<xercesc::DOMElement*>::const_iterator pos;
+   for (pos = skinElementVec.begin(); pos != skinElementVec.end(); pos++)
+   {
+     structureElement->appendChild(*pos);
+   }
+   for (pos = borderElementVec.begin(); pos != borderElementVec.end(); pos++)
+   {
+     structureElement->appendChild(*pos);
+   }
+}
+
 void G4GDMLWriteStructure::StructureWrite(xercesc::DOMElement* gdmlElement)
 {
@@ -197,9 +352,9 @@
    G4VSolid* solidPtr = volumePtr->GetSolid();
    G4Transform3D R,invR;
-   G4int reflected = 0;
+   G4int trans=0;
 
    while (true) // Solve possible displacement/reflection
    {            // of the referenced solid!
-      if (reflected>maxReflections)
+      if (trans>maxTransforms)
       {
         G4String ErrorMessage = "Referenced solid in volume '"
@@ -214,5 +369,5 @@
          R = R*refl->GetTransform3D();
          solidPtr = refl->GetConstituentMovedSolid();
-         reflected++;
+         trans++;
          continue;
       }
@@ -223,5 +378,5 @@
                              disp->GetObjectTranslation());
          solidPtr = disp->GetConstituentMovedSolid();
-         reflected++;
+         trans++;
          continue;
       }
@@ -230,6 +385,7 @@
    }
 
-   if (reflected>0) { invR = R.inverse(); }
-     // Only compute the inverse when necessary!
+   // Only compute the inverse when necessary!
+   //
+   if (trans>0) { invR = R.inverse(); }
 
    const G4String name
@@ -318,4 +474,5 @@
          PhysvolWrite(volumeElement,physvol,invR*P*daughterR,ModuleName);
       }
+      BorderSurfaceCache(GetBorderSurface(physvol));
    }
 
@@ -326,8 +483,13 @@
    VolumeMap()[volumePtr] = R;
 
-   G4GDMLWriteMaterials::AddMaterial(volumePtr->GetMaterial());
+   AddExtension(volumeElement, volumePtr);
+     // Add any possible user defined extension attached to a volume
+
+   AddMaterial(volumePtr->GetMaterial());
      // Add the involved materials and solids!
 
-   G4GDMLWriteSolids::AddSolid(solidPtr);
+   AddSolid(solidPtr);
+
+   SkinSurfaceCache(GetSkinSurface(volumePtr));
 
    return R;
Index: trunk/source/persistency/gdml/src/G4STRead.cc
===================================================================
--- trunk/source/persistency/gdml/src/G4STRead.cc	(revision 1227)
+++ trunk/source/persistency/gdml/src/G4STRead.cc	(revision 1228)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4STRead.cc,v 1.3 2008/07/17 14:05:50 gcosmo Exp $
-// GEANT4 tag $Name: geant4-09-02-ref-02 $
+// $Id: G4STRead.cc,v 1.4 2009/04/24 15:34:20 gcosmo Exp $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // class G4STRead Implementation
@@ -33,5 +33,15 @@
 // -------------------------------------------------------------------------
 
+#include <fstream>
+
 #include "G4STRead.hh"
+
+#include "G4Material.hh"
+#include "G4Box.hh"
+#include "G4QuadrangularFacet.hh"
+#include "G4TriangularFacet.hh"
+#include "G4TessellatedSolid.hh"
+#include "G4LogicalVolume.hh"
+#include "G4PVPlacement.hh"
 
 void G4STRead::TessellatedRead(const std::string& line)
Index: trunk/source/physics_lists/History
===================================================================
--- trunk/source/physics_lists/History	(revision 1227)
+++ trunk/source/physics_lists/History	(revision 1228)
@@ -1,3 +1,3 @@
-$Id: History,v 1.78 2009/02/19 12:49:56 vnivanch Exp $
+q$Id: History,v 1.119 2009/12/04 13:09:12 gcosmo Exp $
 -------------------------------------------------------------------
 
@@ -16,13 +16,203 @@
      ----------------------------------------------------------
 
+04-12-2009, K.Murakami                  (phys-lists-V09-02-46)
+- Fixed typo in FTFP_EMV.icc for wrong call to G4WarnPLStatus.
+
+03-12-2009, P.Kaitaniemi                (phys-lists-V09-02-45)
+- QGSP_INCL_ABLA, Fix: Use Bertini cascade for kaons in the energy range 0 - 10 GeV.
+
+30-11-2009, M.Kosov                     (phys-lists-V09-02-44)
+- G4QNeutrinoPhysics - process is not created if neutrino is not simulated
+
+28-11-2009, V.Ivanchenko                (phys-lists-V09-02-43)
+- QBBC - fixed cross sections for hadron elastic
+
+27-11-2009, G.Folger                    (phys-lists-V09-02-42)
+- QGSP_BERT_TRV, change transition energies in HadronPhysicsQGSP_BERT_TRV to 
+   use BERT ]0,9.9], LEP [9.5, 15], QGSP [10, inf[
+- QGSP_BERT_NOLEP, use G4HadronQElasticPhysics  
+- explicitely mark experimental: QGSP_BERT_EMX, QGSP_BERT_TRV, QGSP_FTFP_BERT, 
+     QGSP_INCL_ABLA
+- mark as obsolete: FTFP, QGSP, QGSC, QGSC_CHIPS, QGSC_EMV, QGSC_QGSC 
+- mark supported ( remove experimental) :FTFP_BERT,  FTFP_BERT_EMV
+- Add initial version of G4IonQMDPhysics    
+   
+25-11-2009, V.Ivanchenko                  (phys-lists-V09-02-41)
+- G4PhysListFactory - update list of supported referenced PhysicsLists
+- QBBC - updated for the release
+
+24-11-2009, V.Ivanchenko                  (phys-lists-V09-02-40)
+- G4EmStandardPhysics_option3, G4EmLivermorePhysics, G4EmPenelopePhysics,
+  G4EmLivermorePolarizedPhysics - set finalRange=10um for ions
+- G4EmStandardPhysics_option2 - use default StepFunction for ions
+
+20-11-2009, M.Kosov                       (phys-lists-V09-02-39)
+- Something was wrong in CHIPS lis, but now it is working
+
+20-11-2009, M.Kosov                       (phys-lists-V09-02-38)
+- G4QAtomicPhysics and xs_dependent is excluded from the GNUmakefile's
+
+18-11-2009, M.Kosov                       (phys-lists-V09-02-37)
+- bug fix in CHIPS.icc (call for G4QCaptureAtRestPhysics)
+
+17-11-2009, M.Kosov                       (phys-lists-V09-02-36)
+- improved dependencies on CHIPS
+
+16-11-2009, M.Kosov                       (phys-lists-V09-02-35)
+- dependencies on split CHIPS-body and new class G4QCaptureAtRestPhysics
+
+13-11-2009, M.Kosov                       (phys-lists-V09-02-34)
+- two builders G4QNeutrinoPhysics & G4QPhotoNuclearPhysics with
+  the G4QMessenger are added to the CHIPS physics list
+
+10-11-2009, V.Ivanchenko                  (phys-lists-V09-02-33)
+- G4EmStandardPhysics_option3, G4EmLivermorePhysics, G4EmPenelopePhysics,
+  G4EmLivermorePolarizedPhysics - added G4NuclearStopping process for 
+                                  GenericIon, He3, alpha particles
+
+4-11-2009, P.Gumplinger                   (phys-lists-V09-02-32)
+- add G4OpticalPhysics and G4OpticalPhysicsMessenger class
+
+3-11-2009, M.Kosov                        (phys-lists-V09-02-31)
+- close the warning about not used quasiElastic
+
+31-10-2009, V.Ivanchenko                   (phys-lists-V09-02-30)
+- G4EmDNAPhysics (S.Inserti) updated combined Physics List standard/DNA
+
+30-10-2009, V.Ivanchenko                   (phys-lists-V09-02-29)
+- Review of all EM builders: 
+   - in all builders separate definition of processes for He3 and 
+     He4 ions; G4eMultipleScattering for e+, e-,
+     G4MuMultipleScattering for muons; 
+   - G4UrbanMscModel93 for e+- for all builders except Opt0 and Opt1
+   - G4WentzelVIModel for muons for all builders except Opt0 and Opt1
+   - G4ParameterizedIonModel for Opt3 and all combined builders
+   - StepFunction (0.1, 0.02*mm) for ions inside Opt2  
+
+30-10-2009, M.Kosov                        (phys-lists-V09-02-28)
+- first implementation of the one model CHIPS physics list
+
+08-10-2009, V.Ivanchenko                   (phys-lists-V09-02-27)
+- fixed compillation problem in G4HadronPhysicsQBBC
+
+04-10-2009, V.Ivanchenko                   (phys-lists-V09-02-26)
+- modified QBBC - remove template and move QBBC.icc to QBBC.cc;
+                  use a new G4VHadronPhysics interface
+- G4HadroHElasticPhysics uses G4WHadronElasticProcess (the result of 
+   redesign of elastic) instead of G4UHadronElasticProcess    
+- QGSP_BERT_EMV uses G4HadroHElasticPhysics instead of G4HadroElasticPhysics  
+
+02-10-2009, V.Ivanchenko                   (phys-lists-V09-02-25)
+- modified EM standard Physics Lists
+G4EmStandardPhysics         - return 9.2 configuration
+G4EmStandardPhysics_option1 - use ApplyCuts=true
+G4EmStandardPhysics_option2 - use G4eMultipleScattering for e+-
+
+09-09-2009, S.Incerti                      (phys-lists-V09-02-24)
+- added high energy limit to e- models for better clarity in
+G4EmLivermorePhysics.cc
+G4EmLivermorePolarizedPhysics.cc
+
+19-07-2009, P.Kaitaniemi                   (phys-lists-V09-02-23)
+- Added INCL/ABLA physics builders for protons, neutrons, pions and light ions
+- Added QGSP_INCL_ABLA physics list
+- Added QGSP_INCL_ABLA to the G4PhysListFactory
+
+08-07-2009, S.Incerti                      (phys-lists-V09-02-22)
+- adapted G4EmLivermorePolarizedPhysics builder similarly to
+the non polarized case
+
+03-06-2009, G.Folger                       (phys-lists-V09-02-21)
+- no code change
+- use versions of phys-lists-V09-02-18 for 
+   builders/include/G4QGSC_CHIPSNeutronBuilder.hh
+   builders/*/G4QNeutronBuilder.{hh,cc}
+   
+
+02-06-2009, G.Folger                       (phys-lists-V09-02-20)
+- Rename HadronPhysicsFB68.{hh,cc} to HadronPhysicsFTFP_BERT_TRV.{hh,cc};
+   required changes in FTFP_BERT_TRV.icc as well.
+- correct typo in experimental/Unsupported names in FTF_BIC.icc and QGSP_EMX.icc
+   
+25-05-2009, M.Kosov                        (phys-lists-V09-02-19)
+- Two new low energy (<290 MeV) nA CHIPS reactions are implemented in the QGSC_CHIPS
+  physics list (works together with the hadr-chips-inter-V09-02-07 CHIPS tag
+
+18-05-2009, G.Folger                       (phys-lists-V09-02-18)
+- Declare several list obsolete, partially disabling use.
+  Obsolete + disabled  (= remove)
+     FTF_EMV,   replacment FTFP_BERT_EMV
+     QGSC_EFLOW, replacment QGSC_CHIPS
+     QGSP_EMX, replacment QGSP_BERT_EMX
+  Obsolete:
+     FTFC
+     LHEP_BERT, LHEP_BERT_HP, LHEP_PRECO_HP
+     QGSP_BERT_DIF, QGSP_BERT_NQE, QGSP_DIF, QGSP_EMV, QGSP_EMV_NQE,
+     QGSP_NQE, QGSP_QEL  
+
+11-05-2009, V.Ivanchenko phys-lists-V09-02-17
+- Added new PhysLists with special EM options: FTFP_BERT_EMV,
+  FTFP_BERT_EMX, QGSP_BERT_EMX, QGSP_BIC_EMY (opt3 EM physics)
+- Renamed FB68 to FTFP_BERT_TRV
+- G4PhysicsListFactory - updated list of supported PhysLists
+
+10-05-2009, V.Ivanchenko phys-lists-V09-02-16
+G4EmStandardPhysics, G4EmStandardPhysics_option1 - use 9.2 msc
+                                                   model for e+-
+G4EmStandardPhysics_option2 - use G4WentzelVIModel for e+-
+G4EmStandardPhysics_option3 - use updated G4UrbanMscModel2 and 
+                              use G4RayleighScattering
+G4EmLivermorePhysics - upper limit of Livermore models 1 GeV
+
+23-04-2009, J.Apostolakis phys-lists-V09-02-15
+- Added MaxEnergy method in FTF builders.
+- Added QGSP_FTFP_BERT based on QGSP_BERT replacing the bridging LEP with FTFP, 
+  and transitioning from BERT to FTFP between 7 and 9 GeV;
+- Added FB68 as variant of FTFP_BERT with transition between 6 and 8 GeV. 
+
+20-04-2009, M.Kosov phys-lists-V09-02-14
+- Two new physics lists QGSC_QGSC and QGSC_CHIPS are added.
+- QGSC_QGSC physics list uses the QGS model with the MultySoft
+  interface to CHIPS at all energies, starting from E=0. For neutrons
+  it still uses LHEP models for the radiativ capture and fission.
+- QGSC_CHIPS physics list uses the QGS model with the EnergyFlow
+  interface to CHIPS at all energies. For the pA interactions the
+  native CHIPS process G4QCollision is used below 290 MeV. The QGSC and
+  G4QCollision processes are joined in one process by the CHIPS
+  G4QDiscProcessMixer interface.
+- The corresponding physics builders are added.
+
+17-04-2009, V.Ivanchenko phys-lists-V09-02-12
+- Restore History after modification of CHIPS builders
+- Fixed G4EmLivermorePhysics, G4EmPenelopePhysics
+- Added new CHIPS PhysLists to the G4PhysListFactory
+- Fixed G4HadronInelasticQBBC - cross sections are created by new, 
+  not by value, fission only instantiated for HP
+
+31-03-2009, V.Ivanchenko phys-lists-V09-02-05
+- To fix bug #1056 all cross section data sets are included not as a
+  member of classes but created by new
+- inline constructor and destructors are moved to source for classes:
+  G4VNeutronBuilder, G4VPiKBuilder, G4VProtonBuilder, G4WarnPLStatus
+
+26-03-2009, S.Incerti phys-lists-V09-02-04
+- Added builders for Livermore and Penelope physics processes:
+  G4EmLivermorePhysics, G4EmLivermorePolarizedPhysics, G4EmPenelopePhysics.
+
+25-03-2009, S.Incerti phys-lists-V09-02-03
+- Added builder for DNA physics processes: G4EmDNAPhysics.
+
+12-03-2009, V.Ivanchenko phys-lists-V09-02-02
+- HadronPhysicsQGSC: fixed crash at destruction.
+
 16-02-2009, V.Ivanchenko phys-lists-V09-02-01
-G4IonBinaryCascadePhysics - use Shen cross section only if Tripathi is
-                            not applicable (fixed order of x-sections)
-G4HadronInelasticQBBC - use G4StringChipsParticleLevelInterface instead of
-                        obsolete G4StringChipsInterface
+- G4IonBinaryCascadePhysics: use Shen cross section only if Tripathi is
+  not applicable (fixed order of x-sections).
+- G4HadronInelasticQBBC: use G4StringChipsParticleLevelInterface instead of
+  obsolete G4StringChipsInterface.
 
 05-02-2009, V.Ivanchenko phys-lists-V09-02-00
-G4MiscLHEPBuilder - create processes by "new" in order to have proper deletion 
-  at the end of run
+- G4MiscLHEPBuilder: create processes by "new" in order to have proper
+  deletion at the end of job.
 
 05-12-2008, G.Cosmo phys-lists-V09-01-20
@@ -32,6 +222,6 @@
 
 01-12-2008, V.Ivanchenko phys-lists-V09-01-19
-G4HadronElasticPhysics - fixed adding optional Barashenkov Xsection
-QBBC - added QBBBG option
+- G4HadronElasticPhysics: fixed adding optional Barashenkov Xsection
+  QBBC - added QBBBG option
 
 21-11-2008, V.Ivanchenko phys-lists-V09-01-18
Index: trunk/source/physics_lists/builders/GNUmakefile
===================================================================
--- trunk/source/physics_lists/builders/GNUmakefile	(revision 1227)
+++ trunk/source/physics_lists/builders/GNUmakefile	(revision 1228)
@@ -1,3 +1,3 @@
-# $Id: GNUmakefile,v 1.10 2009/11/20 10:24:28 mkossov Exp $
+# $Id: GNUmakefile,v 1.11 2009/11/27 17:26:44 gunter Exp $
 # ---------------------------------------------------------------------------
 # GNUmakefile for physics_lists/builders library.  Gunter Folger 25-Oct-2006.
@@ -50,4 +50,5 @@
             -I$(G4BASE)/processes/hadronic/models/binary_cascade/include \
             -I$(G4BASE)/processes/hadronic/models/cascade/cascade/include \
+	    -I$(G4BASE)/processes/hadronic/models/qmd/include \
             -I$(G4BASE)/processes/hadronic/models/chiral_inv_phase_space/body/include \
             -I$(G4BASE)/processes/hadronic/models/chiral_inv_phase_space/cross_sections/include \
Index: trunk/source/physics_lists/builders/include/G4BertiniNeutronBuilder.hh
===================================================================
--- trunk/source/physics_lists/builders/include/G4BertiniNeutronBuilder.hh	(revision 1227)
+++ trunk/source/physics_lists/builders/include/G4BertiniNeutronBuilder.hh	(revision 1228)
@@ -25,5 +25,5 @@
 //
 // $Id: G4BertiniNeutronBuilder.hh,v 1.2 2009/03/31 18:38:33 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-03 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //---------------------------------------------------------------------------
Index: trunk/source/physics_lists/builders/include/G4BertiniPiKBuilder.hh
===================================================================
--- trunk/source/physics_lists/builders/include/G4BertiniPiKBuilder.hh	(revision 1227)
+++ trunk/source/physics_lists/builders/include/G4BertiniPiKBuilder.hh	(revision 1228)
@@ -25,5 +25,5 @@
 //
 // $Id: G4BertiniPiKBuilder.hh,v 1.2 2009/03/31 18:38:33 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-03 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //---------------------------------------------------------------------------
Index: trunk/source/physics_lists/builders/include/G4BertiniProtonBuilder.hh
===================================================================
--- trunk/source/physics_lists/builders/include/G4BertiniProtonBuilder.hh	(revision 1227)
+++ trunk/source/physics_lists/builders/include/G4BertiniProtonBuilder.hh	(revision 1228)
@@ -25,5 +25,5 @@
 //
 // $Id: G4BertiniProtonBuilder.hh,v 1.2 2009/03/31 18:38:33 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-03 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //---------------------------------------------------------------------------
Index: trunk/source/physics_lists/builders/include/G4BinaryNeutronBuilder.hh
===================================================================
--- trunk/source/physics_lists/builders/include/G4BinaryNeutronBuilder.hh	(revision 1227)
+++ trunk/source/physics_lists/builders/include/G4BinaryNeutronBuilder.hh	(revision 1228)
@@ -25,5 +25,5 @@
 //
 // $Id: G4BinaryNeutronBuilder.hh,v 1.2 2009/03/31 18:38:33 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-03 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //---------------------------------------------------------------------------
Index: trunk/source/physics_lists/builders/include/G4BinaryPiKBuilder.hh
===================================================================
--- trunk/source/physics_lists/builders/include/G4BinaryPiKBuilder.hh	(revision 1227)
+++ trunk/source/physics_lists/builders/include/G4BinaryPiKBuilder.hh	(revision 1228)
@@ -25,5 +25,5 @@
 //
 // $Id: G4BinaryPiKBuilder.hh,v 1.2 2009/03/31 18:38:33 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-03 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //---------------------------------------------------------------------------
Index: trunk/source/physics_lists/builders/include/G4BinaryProtonBuilder.hh
===================================================================
--- trunk/source/physics_lists/builders/include/G4BinaryProtonBuilder.hh	(revision 1227)
+++ trunk/source/physics_lists/builders/include/G4BinaryProtonBuilder.hh	(revision 1228)
@@ -25,5 +25,5 @@
 //
 // $Id: G4BinaryProtonBuilder.hh,v 1.2 2009/03/31 18:38:33 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-03 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //---------------------------------------------------------------------------
Index: trunk/source/physics_lists/builders/include/G4ChargeExchangePhysics.hh
===================================================================
--- trunk/source/physics_lists/builders/include/G4ChargeExchangePhysics.hh	(revision 1227)
+++ trunk/source/physics_lists/builders/include/G4ChargeExchangePhysics.hh	(revision 1228)
@@ -25,5 +25,5 @@
 //
 // $Id: G4ChargeExchangePhysics.hh,v 1.1 2008/11/20 12:38:11 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-03 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //---------------------------------------------------------------------------
Index: trunk/source/physics_lists/builders/include/G4DataQuestionaire.hh
===================================================================
--- trunk/source/physics_lists/builders/include/G4DataQuestionaire.hh	(revision 1227)
+++ trunk/source/physics_lists/builders/include/G4DataQuestionaire.hh	(revision 1228)
@@ -33,15 +33,15 @@
 #include "G4VPiKBuilder.hh"
 
-enum G4DataType {no, photon, neutron, radioactive, lowenergy};
+enum G4DataType {no, photon, neutron, radioactive, lowenergy, optical};
 class G4DataQuestionaire
 {
   public: 
-    G4DataQuestionaire(G4DataType t1=no, G4DataType t2=no, G4DataType t3=no, G4DataType t4=no) 
+    G4DataQuestionaire(G4DataType t1=no, G4DataType t2=no, G4DataType t3=no, G4DataType t4=no, G4DataType t5=no) 
     {
       G4cout << G4endl;
-      G4cout << "<<< Geant4 Physics List engine packaging library: PACK 5.4"<<G4endl;
+      G4cout << "<<< Geant4 Physics List engine packaging library: PACK 5.5"<<G4endl;
       //      G4cout <<G4endl<<G4endl;
       // G4cout << "##### the input "<<t1<<" "<<t2<<" "<<t3<<" "<<t4<<G4endl;
-      for(G4int i=0; i<4; i++)
+      for(G4int i=0; i<5; i++)
       {
 	G4DataType t(no);
@@ -50,4 +50,5 @@
 	if(i==2) t=t3;
 	if(i==3) t=t4;
+	if(i==4) t=t5;
 	switch(t)
 	{
@@ -96,4 +97,15 @@
 	    }
 	    break;
+          case optical:
+	    if(!getenv("G4LEDATA") )
+	    {
+	      G4cout << "Data describing surface propeties for optical photons are needed."<<G4endl;
+	      G4cout << "Please set the environmental variable G4REALSURFACEDATA"<<G4endl;
+	      G4cout << "to point to your RealSurface directory."<<G4endl;
+	      G4cout << "Data are available from the Geant4 download page."<<G4endl;
+              G4Exception("G4DataQuestionaire", "007", FatalException,
+	                  "Fatal error: Missing mandatory data for this simulation engine");
+	    }
+	    break;
 	  case no:
 	    // all ok
Index: trunk/source/physics_lists/builders/include/G4DecayPhysics.hh
===================================================================
--- trunk/source/physics_lists/builders/include/G4DecayPhysics.hh	(revision 1227)
+++ trunk/source/physics_lists/builders/include/G4DecayPhysics.hh	(revision 1228)
@@ -25,5 +25,5 @@
 //
 // $Id: G4DecayPhysics.hh,v 1.2 2009/11/05 01:24:47 gum Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-03 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //---------------------------------------------------------------------------
Index: trunk/source/physics_lists/builders/include/G4EmDNAPhysics.hh
===================================================================
--- trunk/source/physics_lists/builders/include/G4EmDNAPhysics.hh	(revision 1227)
+++ trunk/source/physics_lists/builders/include/G4EmDNAPhysics.hh	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4EmDNAPhysics.hh,v 1.1 2009/03/25 11:28:07 sincerti Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-03 $
+// GEANT4 tag $Name: geant4-09-03 $
 
 #ifndef G4EmDNAPhysics_h
Index: trunk/source/physics_lists/builders/include/G4EmExtraPhysics.hh
===================================================================
--- trunk/source/physics_lists/builders/include/G4EmExtraPhysics.hh	(revision 1227)
+++ trunk/source/physics_lists/builders/include/G4EmExtraPhysics.hh	(revision 1228)
@@ -25,5 +25,5 @@
 //
 // $Id: G4EmExtraPhysics.hh,v 1.2 2007/11/15 18:08:11 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-03 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //---------------------------------------------------------------------------
Index: trunk/source/physics_lists/builders/include/G4EmLivermorePhysics.hh
===================================================================
--- trunk/source/physics_lists/builders/include/G4EmLivermorePhysics.hh	(revision 1227)
+++ trunk/source/physics_lists/builders/include/G4EmLivermorePhysics.hh	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4EmLivermorePhysics.hh,v 1.1 2009/03/25 20:54:32 sincerti Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-03 $
+// GEANT4 tag $Name: geant4-09-03 $
 
 #ifndef G4EmLivermorePhysics_h
Index: trunk/source/physics_lists/builders/include/G4EmLivermorePolarizedPhysics.hh
===================================================================
--- trunk/source/physics_lists/builders/include/G4EmLivermorePolarizedPhysics.hh	(revision 1227)
+++ trunk/source/physics_lists/builders/include/G4EmLivermorePolarizedPhysics.hh	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4EmLivermorePolarizedPhysics.hh,v 1.1 2009/03/25 20:54:32 sincerti Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-03 $
+// GEANT4 tag $Name: geant4-09-03 $
 
 #ifndef G4EmLivermorePolarizedPhysics_h
Index: trunk/source/physics_lists/builders/include/G4EmMessenger.hh
===================================================================
--- trunk/source/physics_lists/builders/include/G4EmMessenger.hh	(revision 1227)
+++ trunk/source/physics_lists/builders/include/G4EmMessenger.hh	(revision 1228)
@@ -25,5 +25,5 @@
 //
 // $Id: G4EmMessenger.hh,v 1.1 2006/10/31 11:35:01 gunter Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-03 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 //---------------------------------------------------------------------------
Index: trunk/source/physics_lists/builders/include/G4EmPenelopePhysics.hh
===================================================================
--- trunk/source/physics_lists/builders/include/G4EmPenelopePhysics.hh	(revision 1227)
+++ trunk/source/physics_lists/builders/include/G4EmPenelopePhysics.hh	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4EmPenelopePhysics.hh,v 1.1 2009/03/25 13:24:57 pandola Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-03 $
+// GEANT4 tag $Name: geant4-09-03 $
 
 #ifndef G4EmPenelopePhysics_h
